/* Scheduler include files. */
/*#include "FreeRTOS.h"
#include "task.h"
#include "timers.h"
#include "semphr.h"

#include "FreeRTOS_IP.h"
#include "FreeRTOS_Sockets.h"
#include "FreeRTOS_DHCP.h"
#include "NetworkBufferManagement.h"
#include "FreeRTOS_ARP.h"*/
#include "freeRTOS_include.h"

#include "stdio_serial.h"
#include <string.h>
#include <asf.h>
#include "conf_board.h"
#include "conf_clock.h"


void vApplicationMallocFailedHook( void );
void vApplicationIdleHook( void );
void vApplicationStackOverflowHook( TaskHandle_t pxTask, char *pcTaskName );
void vApplicationTickHook( void );
void vTCPSend( char  *pcBufferToTransmit, const size_t xTotalLengthToSend );
void vApplicationPingReplyHook( ePingReplyStatus_t eStatus, uint16_t usIdentifier );
void vCreateTCPClientSocket( void );
void vCreateTCPServerSocket( void );

/**
 *  \brief Configure UART console.
 */
static void configure_console(void)
{
	const usart_serial_options_t uart_serial_options = {
		.baudrate = CONF_UART_BAUDRATE,
#if (defined CONF_UART_CHAR_LENGTH)
		.charlength = CONF_UART_CHAR_LENGTH,
#endif
		.paritytype = CONF_UART_PARITY,
#if (defined CONF_UART_STOP_BITS)
		.stopbits = CONF_UART_STOP_BITS,
#endif
	};

	/* Configure UART console. */
	sysclk_enable_peripheral_clock(CONSOLE_UART_ID);
	stdio_serial_init(CONF_UART, &uart_serial_options);
#if defined(__GNUC__)
	setbuf(stdout, NULL);
#endif
}

UBaseType_t uxRand(void);
//BaseType_t xApplicationGetRandomNumber(uint32_t* pulNumber);
BaseType_t xApplicationDNSQueryHook( const char *pcName );
const char *pcApplicationHostnameHook( void );
extern uint32_t ulApplicationGetNextSequenceNumber( uint32_t ulSourceAddress, uint16_t usSourcePort, uint32_t ulDestinationAddress, uint16_t usDestinationPort );


static void prvSRand( UBaseType_t ulSeed );
static void vEthernetInit( void );
static UBaseType_t ulNextRand;

//const uint8_t ucMACAddress[ 6 ] = {0};
//int ethernet_phy_addr = (192 << 24) || (168 << 16) || (150 << 8) || (200 << 0);

uint8_t ucMACAddress[ 6 ] = { configMAC_ADDR0, configMAC_ADDR1, configMAC_ADDR2, configMAC_ADDR3, configMAC_ADDR4, configMAC_ADDR5 };
static uint8_t ucIPAddress[ 4 ] = { configIP_ADDR0, configIP_ADDR1, configIP_ADDR2, configIP_ADDR3 };
static const uint8_t ucNetMask[ 4 ] = { configNET_MASK0, configNET_MASK1, configNET_MASK2, configNET_MASK3 };
static const uint8_t ucGatewayAddress[ 4 ] = { configGATEWAY_ADDR0, configGATEWAY_ADDR1, configGATEWAY_ADDR2, configGATEWAY_ADDR3 };
static const uint8_t ucDNSServerAddress[ 4 ] = { configDNS_SERVER_ADDR0, configDNS_SERVER_ADDR1, configDNS_SERVER_ADDR2, configDNS_SERVER_ADDR3 };
	
#define mainHOST_NAME					"RTOSDemo"
#define mainDEVICE_NICK_NAME			"SAME70N19A-Custom"	
	
	

static void qFirstTask( void *pvParameters );
static void qSecTask( void *pvParameters );
static void qSender( void *pvParameters );
static void qIntButt( void *pvParameters );

TaskHandle_t myFirstTaskHandle = NULL, mySecTaskHandle = NULL, myIntTaskHandle = NULL, mySenderTaskHandler = NULL;

static QueueHandle_t xQueue = NULL;
char Messages[30] = {0};


void PIOA_Handler(void)
{
	uint32_t ul_status = pio_get_interrupt_status(PIOA);
	if(ul_status & PIO_PA11){
		if(myIntTaskHandle != NULL)
		{
			//xTaskResumeFromISR (myIntTaskHandle);
			//BaseType_t checkIfYieldRequered;
			//checkIfYieldRequered = xTaskResumeFromISR (myIntTaskHandle);
			//portYIELD_FROM_ISR(checkIfYieldRequered);
			BaseType_t xHigherPriorityTaskWoken;
			xHigherPriorityTaskWoken = pdFALSE;
			vTaskNotifyGiveFromISR (myIntTaskHandle, &xHigherPriorityTaskWoken);
			portYIELD_FROM_ISR(xHigherPriorityTaskWoken);			
		}
	}
	pio_handler_process(PIOA, ID_PIOA);
}



int main (void)
{
	sysclk_init();
	board_init();

	/* Configure debug UART */
	configure_console();
	
	pmc_enable_periph_clk(ID_GMAC);
	pmc_enable_periph_clk(ID_PIOA);
	pmc_enable_periph_clk(ID_PIOB);

	vEthernetInit();
	printf( ( "FreeRTOS_IPInit\n" ) );
	prvSRand( ( uint32_t ) main );
	FreeRTOS_IPInit( ucIPAddress, ucNetMask, ucGatewayAddress, ucDNSServerAddress, ucMACAddress );
	//vCreateTCPClientSocket();
	
	/* Output demo information. */
	printf("-- Freertos Example --\n\r");
	printf("-- %s\n\r", BOARD_NAME);
	printf("-- Compiled: %s %s --\n\r", __DATE__, __TIME__);
	
	/* Insert application code here, after the board has been initialized. */
	irq_initialize_vectors();
	cpu_irq_enable();
	
	
	xTaskCreate(qFirstTask, "Prvni", 500, NULL, tskIDLE_PRIORITY, &myFirstTaskHandle);
	xTaskCreate(qSecTask, "Druhy", 500, NULL, tskIDLE_PRIORITY, &mySecTaskHandle);
	xTaskCreate(qSender, "Sender", 500, NULL, 1, &mySenderTaskHandler);
	xTaskCreate(qIntButt, "ButtonIRQ", 1000, NULL, 1, &myIntTaskHandle);
	
	xQueue = xQueueCreate(5, sizeof(Messages));
	
	vTaskStartScheduler();
	
	for(;;){}
}

static void qFirstTask( void *pvParameters )
{	
	char aMessages[30] = {0};
	for(;;)
	{
		ioport_toggle_pin_level( LED0_GPIO );
		sprintf(aMessages, "FirstTask: %lu \r", (uint32_t)xTaskGetTickCount());
		//puts(aMessages);
		xQueueSend(xQueue, aMessages, 0U);
		//vTaskResume(mySenderTaskHandler);
		vTaskDelay(1000);	
		//FREERTOS_USED
	}
}

static void qSecTask( void *pvParameters )
{
	char aMessages[30] = {0};
	for(;;)
	{
		sprintf(aMessages, "SecTask: %lu \r", (uint32_t)xTaskGetTickCount());
		//puts(aMessages);
		xQueueSend(xQueue, aMessages, 0U);
		//vTaskResume(mySenderTaskHandler);
		vTaskDelay(1000);
	}
}

static void qSender( void *pvParameters )
{	
	if(xQueue != NULL)
	{
		char aMessage[30];
		for (;;)
		{	
			if(xQueueReceive(xQueue, (void*)aMessage, 0xffffffff)==pdPASS) puts (aMessage);
		}
	}
}


static void qIntButt( void *pvParameters )
{
	//BaseType_t xEvent;
	const TickType_t xBlockTime = pdMS_TO_TICKS(500);
	uint32_t ulNotifiedValue;
	for(;;)
	{
		ulNotifiedValue = ulTaskNotifyTake(pdFALSE, xBlockTime);
		if(ulNotifiedValue > 0)
		{
			if(xQueue != NULL)
			{
				char aMessage[30];
				sprintf(aMessage, "Zmackl jsi to tlacitko!\r");
				xQueueSend(xQueue, aMessage, 0U);
				//vTCPSend(NULL, 0);
				const char *Addr = "192.168.150.11";
				FreeRTOS_SendPingRequest (FreeRTOS_inet_addr (Addr), 8, pdMS_TO_TICKS(100));
				vTCPSend(NULL, 0);
			}
		}	
	}	
}



void vApplicationTickHook( void )
{
	
}

/*------------------------------------------------------------------------*/
void vApplicationStackOverflowHook( TaskHandle_t pxTask, char *pcTaskName )
{
	( void ) pcTaskName;
	( void ) pxTask;

	/* Run time stack overflow checking is performed if
	configCHECK_FOR_STACK_OVERFLOW is defined to 1 or 2.  This hook
	function is called if a stack overflow is detected. */

	/* Force an assert. */
	configASSERT( ( volatile void * ) NULL );
}

/**
 * \brief This function is called by FreeRTOS idle task
 */
void vApplicationIdleHook( void )
{
	volatile size_t xFreeHeapSpace;

	/* This is just a trivial example of an idle hook.  It is called on each
	cycle of the idle task.  It must *NOT* attempt to block.  In this case the
	idle task just queries the amount of FreeRTOS heap that remains.  See the
	memory management section on the http://www.FreeRTOS.org web site for memory
	management options.  If there is a lot of heap memory free then the
	configTOTAL_HEAP_SIZE value in FreeRTOSConfig.h can be reduced to free up
	RAM. */
	xFreeHeapSpace = xPortGetFreeHeapSize();

	/* Remove compiler warning about xFreeHeapSpace being set but never used. */
	( void ) xFreeHeapSpace;
}

void vApplicationMallocFailedHook( void )
{
	/* Called if a call to pvPortMalloc() fails because there is insufficient
	free memory available in the FreeRTOS heap.  pvPortMalloc() is called
	internally by FreeRTOS API functions that create tasks, queues, software
	timers, and semaphores.  The size of the FreeRTOS heap is set by the
	configTOTAL_HEAP_SIZE configuration constant in FreeRTOSConfig.h. */

	/* Force an assert. */
	configASSERT( ( volatile void * ) NULL );
}




const char *pcApplicationHostnameHook( void )
{
	/* Assign the name "FreeRTOS" to this network node.  This function will
	be called during the DHCP: the machine will be registered with an IP
	address plus this name. */
	return mainHOST_NAME;
}
/*-----------------------------------------------------------*/


BaseType_t xApplicationDNSQueryHook( const char *pcName )
{
	BaseType_t xReturn;
	/* Determine if a name lookup is for this node.  Two names are given
	to this node: that returned by pcApplicationHostnameHook() and that set
	by mainDEVICE_NICK_NAME. */
	if( strcasecmp( pcName, pcApplicationHostnameHook() ) == 0 )
	{
		xReturn = pdPASS;
	}
	else if( strcasecmp( pcName, mainDEVICE_NICK_NAME ) == 0 )
	{
		xReturn = pdPASS;
	}
	else
	{
		xReturn = pdFAIL;
	}
	return xReturn;
}



/*
 * Callback that provides the inputs necessary to generate a randomized TCP
 * Initial Sequence Number per RFC 6528.  THIS IS ONLY A DUMMY IMPLEMENTATION
 * THAT RETURNS A PSEUDO RANDOM NUMBER SO IS NOT INTENDED FOR USE IN PRODUCTION
 * SYSTEMS.
 */
extern uint32_t ulApplicationGetNextSequenceNumber( uint32_t ulSourceAddress, uint16_t usSourcePort, uint32_t ulDestinationAddress, uint16_t usDestinationPort )
{
	( void ) ulSourceAddress;
	( void ) usSourcePort;
	( void ) ulDestinationAddress;
	( void ) usDestinationPort;
	return uxRand();
}

/*
 * Supply a random number to FreeRTOS+TCP stack. 
 * THIS IS ONLY A DUMMY IMPLEMENTATION THAT RETURNS A PSEUDO RANDOM NUMBER 
 * SO IS NOT INTENDED FOR USE IN PRODUCTION SYSTEMS.
 */
BaseType_t xApplicationGetRandomNumber(uint32_t* pulNumber)
{
	*(pulNumber) = uxRand();
	return pdTRUE;
}

UBaseType_t uxRand(void)
{
	const uint32_t ulMultiplier = 0x015a4e35UL, ulIncrement = 1UL;

	/* Utility function to generate a pseudo random number. */

	ulNextRand = ( ulMultiplier * ulNextRand ) + ulIncrement;
	return( ( int ) ( ulNextRand >> 16UL ) & 0x7fffUL );
}

static void prvSRand( UBaseType_t ulSeed )
{
	/* Utility function to seed the pseudo random number generator. */
	ulNextRand = ulSeed;
}
/*-----------------------------------------------------------*/


void vLoggingPrintf ( const char *pcFormatString, ... )
{
		
}
/*
void vApplicationIPNetworkEventHook( eIPCallbackEvent_t eNetworkEvent )
{
	
}*/

uint32_t tmp;
int res;
static void vEthernetInit()
{
	pio_set_output(PIN_GMAC_RESET_PIO, PIN_GMAC_RESET_MASK, 1,  false, true);
	pio_set_input(PIN_GMAC_INT_PIO, PIN_GMAC_INT_MASK, PIO_PULLUP);
	pio_set_peripheral(PIN_GMAC_PIO, PIN_GMAC_PERIPH, PIN_GMAC_MASK);

	/* Configure GMAC runtime clock */
	res = gmac_set_mdc_clock(GMAC, sysclk_get_cpu_hz());
	tmp = sysclk_get_cpu_hz();
	/* Enable GMAC clock */
}

void vApplicationIPNetworkEventHook( eIPCallbackEvent_t eNetworkEvent )
{
uint32_t ulIPAddress, ulNetMask, ulGatewayAddress, ulDNSServerAddress;
char cBuffer[ 16 ];
static BaseType_t xTasksAlreadyCreated = pdFALSE;

	FreeRTOS_printf( ( "vApplicationIPNetworkEventHook: event %ld\n", eNetworkEvent ) );

	/* If the network has just come up...*/
	if( eNetworkEvent == eNetworkUp )
	{
		/* Create the tasks that use the IP stack if they have not already been
		created. */
		if( xTasksAlreadyCreated == pdFALSE )
		{
			xTasksAlreadyCreated = pdTRUE;
		}

		/* Print out the network configuration, which may have come from a DHCP
		server. */
		FreeRTOS_GetAddressConfiguration( &ulIPAddress, &ulNetMask, &ulGatewayAddress, &ulDNSServerAddress );
		FreeRTOS_inet_ntoa( ulIPAddress, cBuffer );
		printf( "IP Address: %s\r\n", cBuffer );

		FreeRTOS_inet_ntoa( ulNetMask, cBuffer );
		printf( "Subnet Mask: %s\r\n", cBuffer );

		FreeRTOS_inet_ntoa( ulGatewayAddress, cBuffer );
		printf( "Gateway Address: %s\r\n", cBuffer );

		FreeRTOS_inet_ntoa( ulDNSServerAddress, cBuffer );
		printf( "DNS Server Address: %s\r\n", cBuffer );
		
	}
}


U8 rxbuf[512];

void vTCPSend( char  *pcBufferToTransmit, const size_t xTotalLengthToSend )
{
Socket_t xSocket;
struct freertos_sockaddr xRemoteAddress;
BaseType_t xAlreadyTransmitted = 0, xBytesSent = 0;
TaskHandle_t xRxTask = NULL;
size_t xLenToSend;

    /* Set the IP address (192.168.0.50) and port (1500) of the remote socket
    to which this client socket will transmit. */
    xRemoteAddress.sin_port = FreeRTOS_htons( 15000 );
    xRemoteAddress.sin_addr = FreeRTOS_inet_addr_quick( 192, 168, 150, 11 );

    /* Create a socket. */
    xSocket = FreeRTOS_socket( FREERTOS_AF_INET,
                               FREERTOS_SOCK_STREAM,/* FREERTOS_SOCK_STREAM for TCP. */
                               FREERTOS_IPPROTO_TCP );
    configASSERT( xSocket != FREERTOS_INVALID_SOCKET );

    /* Connect to the remote socket.  The socket has not previously been bound to
    a local port number so will get automatically bound to a local port inside
    the FreeRTOS_connect() function. */
    int rxlen;
	if( FreeRTOS_connect( xSocket, &xRemoteAddress, sizeof( xRemoteAddress ) ) == 0 )
    {
        /* Keep sending until the entire buffer has been sent. */
        while(1)
        {
			
			rxlen = FreeRTOS_recv( xSocket, rxbuf, 512, 0 );
			
			if (rxlen > 0)
			{
				/* How many bytes are left to send? */
				//xLenToSend = xTotalLengthToSend - xAlreadyTransmitted;
				xBytesSent = FreeRTOS_send( /* The socket being sent to. */
											xSocket,
											/* The data being sent. */
											rxbuf,
											/* The remaining length of data to send. */
											rxlen,
											/* ulFlags. */
											0 );

				if( xBytesSent >= 0 )
				{
					/* Data was sent successfully. */
					xAlreadyTransmitted += xBytesSent;
				}
				else
				{
					/* Error  break out of the loop for graceful socket close. */
					break;
				}
			}
		}
    }

    /* Initiate graceful shutdown. */
    FreeRTOS_shutdown( xSocket, FREERTOS_SHUT_RDWR );

    /* Wait for the socket to disconnect gracefully (indicated by FreeRTOS_recv()
    returning a FREERTOS_EINVAL error) before closing the socket. */
    while( FreeRTOS_recv( xSocket, pcBufferToTransmit, xTotalLengthToSend, 0 ) >= 0 )
    {
        /* Wait for shutdown to complete.  If a receive block time is used then
        this delay will not be necessary as FreeRTOS_recv() will place the RTOS task
        into the Blocked state anyway. */
        vTaskDelay( ( 250 ) );

        /* Note  real applications should implement a timeout here, not just
        loop forever. */
    }

    /* The socket has shut down and is safe to close. */
    FreeRTOS_closesocket( xSocket );
}




void vCreateTCPClientSocket( void )
{
	Socket_t xClientSocket;
	socklen_t xSize = 16;
	static const TickType_t xTimeOut = pdMS_TO_TICKS( 2000 );

		/* Attempt to open the socket. */
		xClientSocket = FreeRTOS_socket( FREERTOS_AF_INET,
										 FREERTOS_SOCK_STREAM,  /* SOCK_STREAM for TCP. */
										 FREERTOS_IPPROTO_TCP );

		/* Check the socket was created. */
		configASSERT( xClientSocket != FREERTOS_INVALID_SOCKET );

		/* If FREERTOS_SO_RCVBUF or FREERTOS_SO_SNDBUF are to be used with
		FreeRTOS_setsockopt() to change the buffer sizes from their default then do
		it here!.  (see the FreeRTOS_setsockopt() documentation. */

		/* If ipconfigUSE_TCP_WIN is set to 1 and FREERTOS_SO_WIN_PROPERTIES is to
		be used with FreeRTOS_setsockopt() to change the sliding window size from
		its default then do it here! (see the FreeRTOS_setsockopt()
		documentation. */

		/* Set send and receive time outs. */
		FreeRTOS_setsockopt( xClientSocket,
							 0,
							 FREERTOS_SO_RCVTIMEO,
							 &xTimeOut,
							 sizeof( xTimeOut ) );

		FreeRTOS_setsockopt( xClientSocket,
							 0,
							 FREERTOS_SO_SNDTIMEO,
							 &xTimeOut,
							 sizeof( xTimeOut ) );

		/* Bind the socket, but pass in NULL to let FreeRTOS+TCP choose the port number.
		See the next source code snipped for an example of how to bind to a specific
		port number. */
		FreeRTOS_bind( xClientSocket, NULL, xSize );
}



void vApplicationPingReplyHook( ePingReplyStatus_t eStatus, uint16_t usIdentifier )
{
	(void)eStatus;
	(void)usIdentifier;
}